﻿Imports Infragistics.Excel
Imports Infragistics.Win.UltraWinGrid

Public Class Form1

    ''' ***********************************
    ''' 
    '''         Hristo Stoev feat Petur Monov,
    '''         DS Engineer,
    '''         Infragistics Bulgaria
    '''         
    ''' ***********************************


    Public Function HasLetters(ByVal formatsting As String) As Boolean
        For Each ch As Char In formatsting
            If [Char].IsLetter(ch) Then
                Return True
            End If
        Next
        Return False
    End Function


    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        Dim ofd As OpenFileDialog = New OpenFileDialog()
        ofd.Filter = "Excel97To2003 (*.xls)|*.xls|Excel2007 (*.xlsx)|*.xlsx"
        ofd.InitialDirectory = Application.ExecutablePath.Substring(0, Application.ExecutablePath.LastIndexOf("\bin"))
        ofd.FileName = "HitsAutoCMPReport"
        Dim theFile As String
        If ofd.ShowDialog = DialogResult.OK Then
            theFile = ofd.FileName
        Else
            Return
        End If



        Dim table As New DataTable()
        Dim theWorkbook As Workbook



        'Load the Excel File into the Workbook Object

        theWorkbook = Workbook.Load(theFile)

        'We will only work with the first Worksheet in the Workbook
        Dim theWorksheet As Worksheet = theWorkbook.Worksheets(0)


        Dim FirstDataRow As Integer = -1

        For Each reg As WorksheetMergedCellsRegion In theWorksheet.MergedCellsRegions
            If reg.LastRow > FirstDataRow Then
                FirstDataRow = reg.LastRow
            End If
        Next

        For Each theWorksheetCell As WorksheetCell In theWorksheet.Rows(FirstDataRow + 2).Cells
            Dim theDataColumn As DataColumn = table.Columns.Add()
            If theWorksheetCell.Value IsNot Nothing Then
                If theWorksheetCell.Value.[GetType]() IsNot GetType(FormattedString) Then
                    theDataColumn.DataType = theWorksheetCell.Value.[GetType]()
                End If
            End If
            Dim colname As Object = theWorksheet.Rows(FirstDataRow + 1).Cells(theWorksheetCell.ColumnIndex).Value
            theDataColumn.ColumnName = If(colname IsNot Nothing, colname.ToString(), theDataColumn.ColumnName)
        Next

        For row As Integer = FirstDataRow + 2 To theWorksheet.Rows.Count() - 1
            Dim cells As New List(Of Object)()
            For Each theWorksheetCell As WorksheetCell In theWorksheet.Rows(row).Cells
                cells.Add(theWorksheetCell.Value)
            Next
            table.Rows.Add(cells.ToArray())
        Next

        UltraGrid1.DataSource = table

        UltraGrid1.DisplayLayout.Bands(0).RowLayoutStyle = RowLayoutStyle.GroupLayout
        For Each reg As WorksheetMergedCellsRegion In theWorksheet.MergedCellsRegions
            Dim gKey As String = UltraGrid1.DisplayLayout.Bands(0).Groups.Add(reg.Value.ToString()).Key
            For col As Integer = reg.FirstColumn To reg.LastColumn
                UltraGrid1.DisplayLayout.Bands(0).Columns(col).RowLayoutColumnInfo.ParentGroup = UltraGrid1.DisplayLayout.Bands(0).Groups(gKey)
            Next
        Next

    End Sub

    Private Sub button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button2.Click

        If UltraGrid1.DataSource Is Nothing Then
            MessageBox.Show("Please load Excel file", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        End If
        Dim sfd As SaveFileDialog = New SaveFileDialog()
        'Text files (*.txt)|*.txt|All files (*.*)|*.*"
        sfd.Filter = "Excel97To2003 (*.xls)|*.xls|Excel2007 (*.xlsx)|*.xlsx"
        If sfd.ShowDialog() = DialogResult.OK Then

            Select Case sfd.FilterIndex
                Case 1
                    UltraGridExcelExporter1.Export(UltraGrid1, sfd.FileName, WorkbookFormat.Excel97To2003)
                    Exit Select
                Case 2
                    UltraGridExcelExporter1.Export(UltraGrid1, sfd.FileName, WorkbookFormat.Excel2007)
                    Exit Select

            End Select

        End If



    End Sub
End Class
